### Name: Kdot
### Title: Multitype K Function (i-to-any)
### Aliases: Kdot
### Keywords: spatial nonparametric

### ** Examples

     # Lansing woods data: 6 types of trees
    data(lansing)

    ## Not run: 
##D     Kh. <- Kdot(lansing, "hickory") 
##D     
## End(Not run)
    ## Don't show:
    sub <- lansing[seq(1,lansing$n, by=80), ]
    Kh. <- Kdot(sub, "hickory") 
    
## End Don't show
    # diagnostic plot for independence between hickories and other trees
    plot(Kh.)

    # synthetic example with two marks "a" and "b"
    pp <- runifpoispp(50)
    pp <- pp %mark% sample(c("a","b"), pp$n, replace=TRUE)
    K <- Kdot(pp, "a")



